<?php
/**
 * @file
 * Processing for hook_cron().
 */

/**
 * Implements hook_cron().
 *
 * Check to see if we need to send any reminders.
 *
 * If so, send them and update reminders for next occurrance.
 */

function _datereminder_cron() {
  module_load_include('inc', 'datereminder', 'includes/defines');
  module_load_include('inc', 'datereminder', 'includes/messaging');
  module_load_include('inc', 'datereminder', 'includes/date');
  
  $freq = variable_get('datereminder_cron_frequency', DATEREMINDER_CRON_FREQUENCY);
  $freq /= 2;

  // Cron only runs every daterminder_cron_frequency seconds, so
  // we'll fire any reminders that are scheduled to be sent
  // less than half way to the next cron run.
  $dt = _datereminder_now($freq * 60);

  $q = db_query('SELECT * from {datereminder} WHERE next <= \'%s\'', $dt);
  $rems = array();

  while ($r = db_fetch_object($q)) {
    if (!$r->expired) {
      _datereminder_send_reminder($r);
    }
    $rems[$r->rid] = $r;
  }

  _datereminder_update_reminder_nexts($rems);
}
